var _ = require('lodash');

module.exports = function(parties, options) {
  options = options || {};
  parties = _.clone(parties, true);

  var allocated = 0,
    party,
    seats = options.seats || 120,
    totalVotes;

  totalVotes = _.reduce(_.pluck(parties, 'votes'), function(total, votes) {
    return total + (parseInt(votes, 10) || 0);
  }, 0);

  _.each(parties, function(party) {
    party.electorates = parseInt(party.electorates, 10) || 0;
    party.votes = parseInt(party.votes, 10) || 0;
    party.allocated = 0;
    if (party.electorates > 0 || (party.votes / totalVotes) > 0.05) {
      party.quotient = party.votes;
    }

    if (party.votes === -1) {
      seats -= party.electorates;
      party.allocated = party.electorates;
    }
  });

  while (allocated < seats) {
    party = _.max(parties, 'quotient');
    party.allocated++;
    party.quotient = party.votes / ((2 * party.allocated) + 1);
    allocated++;
  }

  return _.map(parties, function(party) {
    if (party.electorates > party.allocated) {
      party.lists = 0;
    } else {
      party.lists = party.allocated - party.electorates;
      if (!_.isUndefined(party, 'listSize') && party.lists > party.listSize) {
        party.lists = parseInt(party.listSize, 10);
      }
    }
    if (party.electorates > party.allocated) {
      party.allocated = party.electorates;
    }

    return _.omit(party, 'quotient');
  });
};
